commit 92cdbeda088e8ae76116d0a8d0b63e1a8fc0fcbf
Author: MikoĊaj Lenczewski <mikolaj@lenczewski.org>
Date: Thu, 21 May 2026 01:28:00 +0100
Initial commit
Diffstat:
17 files changed, 308 insertions(+), 0 deletions(-)
diff --git a/.gitignore b/.gitignore
@@ -0,0 +1,2 @@
+bin/
+obj/
diff --git a/LICENSE b/LICENSE
@@ -0,0 +1,121 @@
+Creative Commons Legal Code
+
+CC0 1.0 Universal
+
+ CREATIVE COMMONS CORPORATION IS NOT A LAW FIRM AND DOES NOT PROVIDE
+ LEGAL SERVICES. DISTRIBUTION OF THIS DOCUMENT DOES NOT CREATE AN
+ ATTORNEY-CLIENT RELATIONSHIP. CREATIVE COMMONS PROVIDES THIS
+ INFORMATION ON AN "AS-IS" BASIS. CREATIVE COMMONS MAKES NO WARRANTIES
+ REGARDING THE USE OF THIS DOCUMENT OR THE INFORMATION OR WORKS
+ PROVIDED HEREUNDER, AND DISCLAIMS LIABILITY FOR DAMAGES RESULTING FROM
+ THE USE OF THIS DOCUMENT OR THE INFORMATION OR WORKS PROVIDED
+ HEREUNDER.
+
+Statement of Purpose
+
+The laws of most jurisdictions throughout the world automatically confer
+exclusive Copyright and Related Rights (defined below) upon the creator
+and subsequent owner(s) (each and all, an "owner") of an original work of
+authorship and/or a database (each, a "Work").
+
+Certain owners wish to permanently relinquish those rights to a Work for
+the purpose of contributing to a commons of creative, cultural and
+scientific works ("Commons") that the public can reliably and without fear
+of later claims of infringement build upon, modify, incorporate in other
+works, reuse and redistribute as freely as possible in any form whatsoever
+and for any purposes, including without limitation commercial purposes.
+These owners may contribute to the Commons to promote the ideal of a free
+culture and the further production of creative, cultural and scientific
+works, or to gain reputation or greater distribution for their Work in
+part through the use and efforts of others.
+
+For these and/or other purposes and motivations, and without any
+expectation of additional consideration or compensation, the person
+associating CC0 with a Work (the "Affirmer"), to the extent that he or she
+is an owner of Copyright and Related Rights in the Work, voluntarily
+elects to apply CC0 to the Work and publicly distribute the Work under its
+terms, with knowledge of his or her Copyright and Related Rights in the
+Work and the meaning and intended legal effect of CC0 on those rights.
+
+1. Copyright and Related Rights. A Work made available under CC0 may be
+protected by copyright and related or neighboring rights ("Copyright and
+Related Rights"). Copyright and Related Rights include, but are not
+limited to, the following:
+
+ i. the right to reproduce, adapt, distribute, perform, display,
+ communicate, and translate a Work;
+ ii. moral rights retained by the original author(s) and/or performer(s);
+iii. publicity and privacy rights pertaining to a person's image or
+ likeness depicted in a Work;
+ iv. rights protecting against unfair competition in regards to a Work,
+ subject to the limitations in paragraph 4(a), below;
+ v. rights protecting the extraction, dissemination, use and reuse of data
+ in a Work;
+ vi. database rights (such as those arising under Directive 96/9/EC of the
+ European Parliament and of the Council of 11 March 1996 on the legal
+ protection of databases, and under any national implementation
+ thereof, including any amended or successor version of such
+ directive); and
+vii. other similar, equivalent or corresponding rights throughout the
+ world based on applicable law or treaty, and any national
+ implementations thereof.
+
+2. Waiver. To the greatest extent permitted by, but not in contravention
+of, applicable law, Affirmer hereby overtly, fully, permanently,
+irrevocably and unconditionally waives, abandons, and surrenders all of
+Affirmer's Copyright and Related Rights and associated claims and causes
+of action, whether now known or unknown (including existing as well as
+future claims and causes of action), in the Work (i) in all territories
+worldwide, (ii) for the maximum duration provided by applicable law or
+treaty (including future time extensions), (iii) in any current or future
+medium and for any number of copies, and (iv) for any purpose whatsoever,
+including without limitation commercial, advertising or promotional
+purposes (the "Waiver"). Affirmer makes the Waiver for the benefit of each
+member of the public at large and to the detriment of Affirmer's heirs and
+successors, fully intending that such Waiver shall not be subject to
+revocation, rescission, cancellation, termination, or any other legal or
+equitable action to disrupt the quiet enjoyment of the Work by the public
+as contemplated by Affirmer's express Statement of Purpose.
+
+3. Public License Fallback. Should any part of the Waiver for any reason
+be judged legally invalid or ineffective under applicable law, then the
+Waiver shall be preserved to the maximum extent permitted taking into
+account Affirmer's express Statement of Purpose. In addition, to the
+extent the Waiver is so judged Affirmer hereby grants to each affected
+person a royalty-free, non transferable, non sublicensable, non exclusive,
+irrevocable and unconditional license to exercise Affirmer's Copyright and
+Related Rights in the Work (i) in all territories worldwide, (ii) for the
+maximum duration provided by applicable law or treaty (including future
+time extensions), (iii) in any current or future medium and for any number
+of copies, and (iv) for any purpose whatsoever, including without
+limitation commercial, advertising or promotional purposes (the
+"License"). The License shall be deemed effective as of the date CC0 was
+applied by Affirmer to the Work. Should any part of the License for any
+reason be judged legally invalid or ineffective under applicable law, such
+partial invalidity or ineffectiveness shall not invalidate the remainder
+of the License, and in such case Affirmer hereby affirms that he or she
+will not (i) exercise any of his or her remaining Copyright and Related
+Rights in the Work or (ii) assert any associated claims and causes of
+action with respect to the Work, in either case contrary to Affirmer's
+express Statement of Purpose.
+
+4. Limitations and Disclaimers.
+
+ a. No trademark or patent rights held by Affirmer are waived, abandoned,
+ surrendered, licensed or otherwise affected by this document.
+ b. Affirmer offers the Work as-is and makes no representations or
+ warranties of any kind concerning the Work, express, implied,
+ statutory or otherwise, including without limitation warranties of
+ title, merchantability, fitness for a particular purpose, non
+ infringement, or the absence of latent or other defects, accuracy, or
+ the present or absence of errors, whether or not discoverable, all to
+ the greatest extent permissible under applicable law.
+ c. Affirmer disclaims responsibility for clearing rights of other persons
+ that may apply to the Work or any use thereof, including without
+ limitation any person's Copyright and Related Rights in the Work.
+ Further, Affirmer disclaims responsibility for obtaining any necessary
+ consents, permissions or other rights required for any use of the
+ Work.
+ d. Affirmer understands and acknowledges that Creative Commons is not a
+ party to this document and has no duty or obligation with respect to
+ this CC0 or use of the Work.
diff --git a/README b/README
@@ -0,0 +1,87 @@
+gp24
+==============================================================================
+Example project on how to lay out a small, multi-language embedded codebase for
+controlling a greenpower racecar.
+
+gp24: Motivation
+==============================================================================
+A greenpower car consists of the following critical systems:
+- Batteries : We need to store energy to do anything
+- Motors : We need to move the car
+- Controls : We need to accept inputs from the driver (i.e. throttle)
+- Heads-Up Display : We need to show things to the driver (i.e. battery level)
+
+Optionally, it may also contain the following systems:
+- Telemetry : We might want to log debug and status information when running
+
+Fundamentally, greenpower is about optimising your battery usage. You want to
+minimise the work the motors have to do to accelerate you to speed and keep
+you there, and want to maximise the time the motors can keep you at speed for.
+
+To do that, we need to minimise the amount of work done by the control system
+beyond that which is absolutely necessary. That means minimal processing on any
+inputs taken from the driver, minimal processing on any inputs taken from the
+car itself, and a minimal GUI to display only the neccessary information.
+
+Alongside this goal of minimising work, however, is the need to know how the
+car is performing. Both for debugging failures, as well as helping with future
+development, we need to at least log the state of the car at regular intervals
+to an SD card (or other removable storage). If the power budget allows, there
+is also the option of using remote telemetry from the car to the pit, to store
+telemetry on the receiving device.
+
+gp24: Architecture
+==============================================================================
+We want to have the ability to target a variety of devices, to potentially
+do initial testing and prototyping on a more ergonomic development board, and
+then refine the result to run on a lower-power board when integrated into the
+final car. To achieve this goal, we need to abstract away from concrete
+microcontrollers as much as possible. To help with this, we write in mainly
+C/C++, with platform-specific assembly helpers and a hardware abstraction
+layer where necessary.
+
+Thus, for each platform that the project targets and builds for, we have
+the following:
+
+```
+<target>.lds - platform-specific linker script
+<target>/plat.S - platform-specific assembly code, used by HAL
+<target>/hal.c - platform-specific hardware abstraction layer
+<target>/*.c - additional platform-specific C source files
+<target>/*.h - additional platform-specific C header files
+```
+
+This HAL is then used by the platform-independent portion of the code,
+located under `src/*.{cpp,hpp,h}`. This is where the bulk of the code exists,
+including the main loop, the graphics code, and the telemetry code.
+
+The top-level source file to start from is `src/gp24.cpp`, which includes all
+further source files in a "unity build" fashion. This approach allows precise
+control over the placement of any static variables, control over the order of
+definition of symbols, avoids multiple rounds of header file parsing, as well
+as cleaning up and simplifying the build script.
+
+Any third-party dependencies, such as header-only libraries, or hardware
+definition headers (e.g. defining memory-mapped addresses), live under the
+`dep/` directory. These may be platform-dependent, and if so their use must
+be guarded by the relevant `#ifdef` guards.
+
+Any documentation is kept under `docs/`.
+
+gp24: Building
+==============================================================================
+To build the project, there exists `build.sh`. When ran without any arguments,
+it will build for the default platform. To specify what platform to build for,
+it is necessary to pass a commandline argument, as follows:
+
+```
+$ ./build.sh <platform> # see `build.sh` for available values for <platform>
+```
+
+Building the project results in an elf file, `bin/gp24.elf`. This is useful
+when debugging, to get symbol information to your debugger of choice. For
+flashing onto the target platform, however, there are also `bin/gp24.bin` and
+`bin/gp24.hex` that are generated. A symbol map is also generated for debugging
+purposes, and can be found at `bin/gp24.map`.
+
+To clean the project, there exists `clean.sh`.
diff --git a/atmega2560.lds b/atmega2560.lds
diff --git a/atmega2560/hal.c b/atmega2560/hal.c
diff --git a/atmega2560/plat.S b/atmega2560/plat.S
@@ -0,0 +1,4 @@
+.globl _start
+
+_start:
+ rjmp .
diff --git a/build.sh b/build.sh
@@ -0,0 +1,81 @@
+#!/bin/sh
+
+TARGET="${1:-atmega2560}"
+
+# toolchain
+AS="clang"
+CC="clang"
+CXX="clang++"
+LD="ld.lld"
+
+OBJCOPY="llvm-objcopy"
+
+# toolchain flags
+WARNINGS="-Wall -Wextra ${WERROR:+-Werror} -Wno-unused-parameter"
+FLAGS="-ffreestanding -fno-builtin"
+
+# generic language flags
+ASFLAGS="-g3"
+CFLAGS="-std=c11 -O0 -g3"
+CXXFLAGS="-std=c++11 -O0 -g3"
+
+CPPFLAGS="-Idep"
+LDFLAGS="-nostdlib"
+
+# target-specific toolchain flags
+# --
+# see: clang -target avr-none --print-supported-cpus
+# see: clang -target arm-none-eabi --print-supported-cpus
+# see: clang -target arm-none-eabi --print-supported-extensions
+#
+# see: https://gcc.gnu.org/onlinedocs/gcc/AVR-Options.html
+# see: https://gcc.gnu.org/onlinedocs/gcc/ARM-Options.html
+case $TARGET in
+ atmega2560) # arduino mega
+ TRIPLE="avr-none"
+ TARGET_FLAGS="-mmcu=atmega2560"
+ ;;
+
+ stm32-m3) # stm nucleo-64
+ TRIPLE="arm-none-eabi"
+ TARGET_FLAGS="-mcpu=cortex-m3 -march=armv7-m"
+ ;;
+
+ stm32-m4) # stm32 nucleo-144
+ TRIPLE="arm-none-eabi"
+ TARGET_FLAGS="-mcpu=cortex-m4 -march=armv7e-m+fp"
+ ;;
+
+ *)
+ echo "Unsupported target: $TARGET, must be one of: "
+ echo "\tatmega2560 stm32-m3 stm32-m4"
+ exit 1
+ ;;
+esac
+
+# target-specific language flags
+ARCH_ASFLAGS="-target $TRIPLE $TARGET_FLAGS $ASFLAGS $FLAGS"
+ARCH_CFLAGS="-target $TRIPLE $TARGET_FLAGS $CFLAGS $FLAGS"
+ARCH_CXXFLAGS="-target $TRIPLE $TARGET_FLAGS $CXXFLAGS $FLAGS"
+
+ARCH_CPPFLAGS="$CPPFLAGS"
+ARCH_LDFLAGS="-T $TARGET.lds $LDFLAGS"
+
+set -ex
+
+mkdir -p bin obj
+
+# build target-specific asm platform code and HAL implementation
+$AS $ARCH_ASFLAGS $ARCH_CPPFLAGS -o obj/plat.o -c $TARGET/plat.S -I$TARGET
+$CC $ARCH_CFLAGS $ARCH_CPPFLAGS -o obj/hal.o -c $TARGET/hal.c -I$TARGET
+
+# build target-independent code
+$CXX $ARCH_CXXFLAGS $ARCH_CPPFLAGS -o obj/gp24.o -c src/gp24.cpp
+
+# link together asm helpers, HAL, and main code
+$LD $ARCH_LDFLAGS --Map=bin/gp24.map --print-memory-usage \
+ obj/plat.o obj/hal.o obj/gp24.o -o bin/gp24.elf
+
+# prepare binary for flashing to target
+$OBJCOPY -S -O binary bin/gp24.elf bin/gp24.bin
+$OBJCOPY -S -O ihex bin/gp24.elf bin/gp24.hex
diff --git a/clean.sh b/clean.sh
@@ -0,0 +1,5 @@
+#!/bin/sh
+
+set -ex
+
+rm -rf bin obj
diff --git a/dep/.keep b/dep/.keep
diff --git a/docs/.keep b/docs/.keep
diff --git a/src/gp24.cpp b/src/gp24.cpp
diff --git a/stm32-m3.lds b/stm32-m3.lds
diff --git a/stm32-m3/hal.c b/stm32-m3/hal.c
diff --git a/stm32-m3/plat.S b/stm32-m3/plat.S
@@ -0,0 +1,4 @@
+.globl _start
+
+_start:
+ b .
diff --git a/stm32-m4.lds b/stm32-m4.lds
diff --git a/stm32-m4/hal.c b/stm32-m4/hal.c
diff --git a/stm32-m4/plat.S b/stm32-m4/plat.S
@@ -0,0 +1,4 @@
+.globl _start
+
+_start:
+ b .